<?php
/**
 * @file
 * Provide user uid argument handler.
 */

/**
 * Argument handler to accept a user uid.
 */
class fbapp_viewsfql_handler_argument_user_uid extends views_handler_argument {

  function option_definition() {
    $options = parent::option_definition();

    $options['relationship_type'] = array('default' => 'specific');

    return $options;
  }

  function options_form(&$form, &$form_state) {
    parent::options_form($form, $form_state);

    $form['relationship_type'] = array(
      '#type' => 'select',
      '#title' => t('Relationship type'),
      '#description' => t('Select the type of relationship to the selected user.'),
      '#default_value' => $this->options['relationship_type'],
      '#options' => array(
        'specific' => t('Get a specific user'),
        'friends' => t('Friends'),
      ),
    );
  }

  function query() {
    switch ($this->options['relationship_type']) {
      case 'specific':
        $query = 'uid = %d';
        break;
      case 'friends':
        $query = 'uid IN (SELECT uid2 FROM friend WHERE uid1 = %d)';
        break;
    }
    $user_info = fbapp_user_fb_data($this->argument, TRUE);
    $this->ensure_my_table();
    $this->query->set_access_token($user_info['access_token']);
    $this->query->add_where(0, $query, array($user_info['fbu']));
  }
}

