<?php
/**
 * @file
 * Provide a views handler for string fields.
 */

class fbapp_viewsfql_handler_field_actor_name extends views_handler_field {

  function query() {
    // Check if the actor_id field already exists, and add it if it doesn't.
    if (!isset($this->query->fields['actor_id'])) {
      $this->ensure_my_table();
      // Add the field.
      $this->field_alias = $this->query->add_field($this->table_alias, 'actor_id');
      $this->add_additional_fields();
    }
  }

  function render($values) {
    $actor_data = $this->query->get_actor_data($values->actor_id);
    return $actor_data->data['name'];
  }
}

