<?php
/**
 * @file
 * Provide a views handler for string fields.
 */

class fbapp_viewsfql_handler_field_actor_pic extends views_handler_field {

  function option_definition() {
    $options = parent::option_definition();

    $options['pic_format'] = array('default' => 'square');

    return $options;
  }

  function options_form(&$form, &$form_state) {
    parent::options_form($form, $form_state);

    $form['pic_format'] = array(
      '#type' => 'select',
      '#title' => t('Picture format'),
      '#description' => t('Select the picture format to display.'),
      '#default_value' => $this->options['pic_format'],
      '#options' => array(
        'square' => t('Square'),
        'small' => t('Small'),
        'normal' => t('Normal'),
        'large' => t('Large'),
      ),
    );
  }

  function query() {
    // Check if the actor_id field already exists, and add it if it doesn't.
    if (!isset($this->query->fields['actor_id'])) {
      $this->ensure_my_table();
      // Add the field.
      $this->field_alias = $this->query->add_field($this->table_alias, 'actor_id');
      $this->add_additional_fields();
    }
  }

  function render($values) {
    return '<img src="https://graph.facebook.com/' . $values->actor_id . '/picture?' . $this->options['pic_format'] . '" />';
  }
}

