<?php
/**
 * @file
 * Provide a views handler for string fields.
 */

class fbapp_viewsfql_handler_field_user_pic extends views_handler_field {

  function option_definition() {
    $options = parent::option_definition();

    $options['pic_format'] = array('default' => 'pic_square');

    return $options;
  }

  function options_form(&$form, &$form_state) {
    parent::options_form($form, $form_state);

    $form['pic_format'] = array(
      '#type' => 'select',
      '#title' => t('Picture format'),
      '#description' => t('Select the picture format to display.'),
      '#default_value' => $this->options['pic_format'],
      '#options' => array(
        'pic_square' => t('Square'),
        'pic_small' => t('Small'),
        'pic' => t('Medium'),
        'pic_big' => t('Big'),
        'pic_square_with_logo' => t('Square with logo'),
        'pic_small_with_logo' => t('Small with logo'),
        'pic_with_logo' => t('Medium with logo'),
        'pic_big_with_logo' => t('Big with logo'),
      ),
    );
  }

  function query() {
    $pic_format = $this->options['pic_format'];
    $this->ensure_my_table();
    // Add the field.
    $this->field_alias = $this->query->add_field($this->table_alias, $pic_format);
    $this->add_additional_fields();
  }

  function render($values) {
    $value = $this->get_value($values);
    return '<img src="' . $value . '" />';
  }
}

