<?php

/**
 * @file
 * Facebook object cache functions.
 *
 * @todo
 * Check if token_expires exists in the object and use the lesser value between that and cache_expiry_time;
 *
 */

/**
 * Check cache before sending request to Facebook.
 */
function fbapp_cache_pre_request($target, $method) {
  // Bypass cache for unwanted requests.
  if ($target != 'me' && $target != variable_get('fbapp_app_id', '') . '/subscriptions') {
    switch ($method) {
      case 'GET':
        $data = cache_get($target, 'cache_fbapp');
        return $data;
    }
  }
  return FALSE;
}

/**
 * Update cache after request to Facebook.
 */
function fbapp_cache_post_request($target, $method, $data = NULL) {
  // Bypass cache for unwanted requests.
  if ($target != 'me' && $target != variable_get('fbapp_app_id', '') . '/subscriptions') {
    switch ($method) {
      case 'DELETE':
        cache_clear_all($target, 'cache_fbapp');
        break;
      case 'GET':
        if ($data != NULL) {
          cache_set($target, $data, 'cache_fbapp', REQUEST_TIME + variable_get('fbapp_cache_expiry_time', 86400));
        }
        break;
    }
  }
}

