<?php

/**
 * @file
 * Callback functions to process notifications.
 *
 * @todo
 * Implement app info modified callback;
 * Validate source address (and add option to add FB addresses);
 *
 */


/**
 * Subscriptions notification callback.
 */
function fbapp_subscriptions_notification() {
  $type = $_GET['type'] == 'perms' ? 'permissions' : $_GET['type'];
  $method = $_SERVER['REQUEST_METHOD'];

  if ($method == 'GET' && $_GET['hub_mode'] == 'subscribe' && $_GET['hub_verify_token'] == variable_get('fbapp_subscriptions_' . $type . '_verify_token', '')) {
    variable_set('fbapp_subscriptions_' . $type . '_verified', 1);
    echo check_plain($_GET['hub_challenge']);
  }
  elseif ($method == 'POST') {
    $updates = json_decode(file_get_contents("php://input"), TRUE);
    foreach ($updates as $type_updates) {
      if ($type_updates['object'] == 'user') {
        foreach ($type_updates['entry'] as $object_update) {
          $fbuser = fbapp_user_fb_data($object_update['uid']);
          $user = user_load($fbuser['uid']);
          // Check if user picture should be updated.
          if (in_array('picture', $object_update['changed_fields'])) {
            fbapp_user_set_picture($user);
          }
          rules_invoke_event('fbapp_user_data_modified', $user, implode(',', $object_update['changed_fields']), $object_update['time']);
        }
      }
      elseif ($type_updates['object'] == 'permissions') {
        foreach ($type_updates['entry'] as $object_update) {
          $fbuser = fbapp_user_fb_data($object_update['uid']);
          $user = user_load($fbuser['uid']);
          rules_invoke_event('fbapp_user_permissions_modified', $user, implode(',', $object_update['changed_fields']), $object_update['time']);
        }
      }
    }
  }
}

/**
 * User installed application callback.
 */
function fbapp_user_install() {
  if (isset($_REQUEST['signed_request'])) {
    $signed_request = fbapp_parse_signed_request($_REQUEST['signed_request'], variable_get('fbapp_app_secret', ''));
    $fbuser = fbapp_user_fb_data($signed_request['user_id']);
    $user = user_load($fbuser['uid']);
    rules_invoke_event('fbapp_user_connected', $user);
  }
}

/**
 * User uninstalled application callback.
 */
function fbapp_user_uninstall() {
  if (isset($_REQUEST['signed_request'])) {
    $signed_request = fbapp_parse_signed_request($_REQUEST['signed_request'], variable_get('fbapp_app_secret', ''));
    $fbuser = fbapp_user_fb_data($signed_request['user_id']);
    $user = user_load($fbuser['uid']);
    rules_invoke_event('fbapp_user_disconnected', $user);
  }
}

/**
 * Application info modified callback.
 */
function fbapp_app_info_modified() {
  error_log('app info modified callback invoked. GET data: ' . implode(',', $_GET));
}

